/* #include "stm8l_discovery_lcd.h" */
#include "discover_board.h"
#include "stm8l15x.h"
#include "stm8l15x_spi.h"
#include "GHZ_SPI.h"
#include "stm8l15x_clk.h"
#include "KS0108.h"
#include <stdio.h>
#include "delay.h"

uint8_t cntr,datah,datal,data0,data1;
int i,RSSI, RSSI_Raw;
uint16_t data[2];
char strnum [10];

const uint8_t Spec_Sym[9]={
  {0x00},{0x80},{0xC0},{0xE0},
  {0xf0},{0xf8},{0xfC},{0xfE},{0xff}  
};

void SpecLine(uint8_t Column, uint8_t Amplitude)
{
  uint8_t i;
 if (Amplitude > 127) Amplitude = 127;
 for (i=0; i<8; i++){
   GLCD_GoTo(Column,i); 
   GLCD_WriteData(Spec_Sym[0]);} 
  
  i=7; 
  while (Amplitude >8) {  
 GLCD_GoTo(Column,i); 
 GLCD_WriteData(Spec_Sym[8]);    
 Amplitude = Amplitude - 8;
 i--;
} 
   
 GLCD_GoTo(Column,i); 
 GLCD_WriteData(Spec_Sym[Amplitude]);  
}


int main( void )
{
  /* Green led init: GPIO set in output */
  GPIO_Init( LED_GREEN_PORT, LED_GREEN_PIN, GPIO_Mode_Out_PP_Low_Fast);
	
/* Blue led init: GPIO set in output */
  GPIO_Init( LED_BLUE_PORT, LED_BLUE_PIN, GPIO_Mode_Out_PP_Low_Fast);

  GPIO_Init(GPIOD, GPIO_Pin_All , GPIO_Mode_Out_PP_High_Fast);
  GPIO_Init(GPIOE, GPIO_Pin_All , GPIO_Mode_Out_PP_High_Fast); 

  GPIO_Init( SPI_SEL_PORT, ETH_SEL_PIN, GPIO_Mode_Out_PP_High_Fast);
  GPIO_Init( SPI_SEL_PORT, GHZ_SEL_PIN, GPIO_Mode_Out_PP_High_Fast);  
  GPIO_Init( GPIOB, GPIO_Pin_5, GPIO_Mode_Out_PP_Low_Fast);  
  GPIO_Init( GPIOB, GPIO_Pin_6, GPIO_Mode_Out_PP_Low_Fast);      
  GPIO_Init( GPIOB, GPIO_Pin_7, GPIO_Mode_In_PU_No_IT);  
  
  CLK_PeripheralClockConfig(CLK_Peripheral_SPI1, ENABLE);

  SPI_Init(SPI1, SPI_FirstBit_MSB, SPI_BaudRatePrescaler_2, SPI_Mode_Master, SPI_CPOL_Low, 
           SPI_CPHA_2Edge, SPI_Direction_2Lines_FullDuplex, SPI_NSS_Soft, 7);
  SPI_Cmd(SPI1, ENABLE);    
  
  GLCD_Initalize();
  GLCD_ClearScreen(); 
  GLCD_GoTo(0, 0);
  GLCD_WriteString("Initializing.");   
  GHZ_Init(); 
  GLCD_WriteString(".");
  delay_ms(100);
  GLCD_WriteString(".");
  delay_ms(100);
  GLCD_WriteString(".");

   cntr = 0;


  GLCD_ClearScreen();  
/* Initializes the LCD glass */
  while (1)
  {
/* GPIO_LOW(LED_GREEN_PORT,LED_GREEN_PIN); */		
 GPIO_HIGH(LED_BLUE_PORT,LED_BLUE_PIN); 
 GHZ_RcvMode (cntr);
data[0] = 0; 

for (i=0; i<6; i++){
data[1]=GHZ_ReadReg(SPI1,0x06);
if (data[1] > data[0]) data[0]=data[1];
}

GPIO_LOW(LED_BLUE_PORT,LED_BLUE_PIN);		

RSSI_Raw=(uint8_t)(data[0]>>9);
RSSI = (uint8_t)(data[0]&0x00FF);

if (RSSI_Raw == 0) RSSI_Raw = 1;
if (RSSI == 0) RSSI = 1;

GPIO_HIGH(LED_GREEN_PORT,LED_GREEN_PIN);	

  
/*  GLCD_GoTo(cntr,6);  
  GLCD_WriteData(Spec_Sym[RSSI_Raw]);    
  GLCD_GoTo(cntr,7);  
  GLCD_WriteData(Spec_Sym[RSSI]);    */
  SpecLine(cntr,RSSI_Raw);
  
GPIO_LOW(LED_GREEN_PORT,LED_GREEN_PIN);	

cntr++;  

 /* delay_ms(10);*/
if (cntr >=128) cntr=0;

  
  }
  
}
